Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Exif.pm	(revision 34921)
@@ -2707,13 +4573,36 @@
             1 => 'JpgFromRawLength',
         },
-        RawConv => 'Image::ExifTool::Exif::ExtractImage($self,$val[0],$val[1],"JpgFromRaw")',
+        Notes => q{
+            this tag is writable, and may be used to update existing embedded images,
+            but not create or delete them
+        },
+        RawConv => q{
+            @grps = $self->GetGroup($$val{0});
+            return Image::ExifTool::Exif::ExtractImage($self,$val[0],$val[1],"JpgFromRaw");
+        },
     },
     OtherImage => {
+        Groups => { 0 => 'EXIF', 1 => 'SubIFD', 2 => 'Preview' },
+        Writable => 1,
+        WriteGroup => 'All',
+        WriteCheck => '$self->CheckImage(\$val)',
+        DelCheck => '$val = ""; return undef', # can't delete, so set to empty string
+        WriteAlso => {
+            OtherImageStart  => 'defined $val ? 0xfeedfeed : undef',
+            OtherImageLength => 'defined $val ? 0xfeedfeed : undef',
+        },
         Require => {
             0 => 'OtherImageStart',
             1 => 'OtherImageLength',
         },
+        Notes => q{
+            this tag is writable, and may be used to update existing embedded images,
+            but not create or delete them
+        },
         # retrieve the thumbnail from our EXIF data
-        RawConv => 'Image::ExifTool::Exif::ExtractImage($self,$val[0],$val[1],"OtherImage")',
+        RawConv => q{
+            @grps = $self->GetGroup($$val{0});
+            Image::ExifTool::Exif::ExtractImage($self,$val[0],$val[1],"OtherImage");
+        },
     },
     PreviewImageSize => {
@@ -2727,40 +4616,57 @@
         Description => 'Date/Time Original',
         Groups => { 2 => 'Time' },
+        Writable => 1,
+        Shift => 0, # don't shift this tag
         Require => {
             0 => 'EXIF:DateTimeOriginal',
+        },
+        Desire => {
             1 => 'SubSecTimeOriginal',
-        },
-        # be careful here just in case there is a timezone following the seconds
-        ValueConv => q{
-            return undef if $val[1] eq '';
-            $_ = $val[0]; s/( \d{2}:\d{2}:\d{2})/$1\.$val[1]/; $_;
-        },
-        PrintConv => '$self->ConvertDateTime($val)',
+            2 => 'OffsetTimeOriginal',
+        },
+        WriteAlso => {
+            'EXIF:DateTimeOriginal' => '($val and $val=~/^(\d{4}:\d{2}:\d{2} \d{2}:\d{2}:\d{2})/) ? $1 : undef',
+            'EXIF:SubSecTimeOriginal' => '($val and $val=~/\.(\d+)/) ? $1 : undef',
+            'EXIF:OffsetTimeOriginal' => '($val and $val=~/([-+]\d{2}:\d{2}|Z)$/) ? ($1 eq "Z" ? "+00:00" : $1) : undef',
+        },
+        %subSecConv,
     },
     SubSecCreateDate => {
         Description => 'Create Date',
         Groups => { 2 => 'Time' },
+        Writable => 1,
+        Shift => 0, # don't shift this tag
         Require => {
             0 => 'EXIF:CreateDate',
+        },
+        Desire => {
             1 => 'SubSecTimeDigitized',
-        },
-        ValueConv => q{
-            return undef if $val[1] eq '';
-            $_ = $val[0]; s/( \d{2}:\d{2}:\d{2})/$1\.$val[1]/; $_;
-        },
-        PrintConv => '$self->ConvertDateTime($val)',
+            2 => 'OffsetTimeDigitized',
+        },
+        WriteAlso => {
+            'EXIF:CreateDate' => '($val and $val=~/^(\d{4}:\d{2}:\d{2} \d{2}:\d{2}:\d{2})/) ? $1 : undef',
+            'EXIF:SubSecTimeDigitized' => '($val and $val=~/\.(\d+)/) ? $1 : undef',
+            'EXIF:OffsetTimeDigitized' => '($val and $val=~/([-+]\d{2}:\d{2}|Z)$/) ? ($1 eq "Z" ? "+00:00" : $1) : undef',
+        },
+        %subSecConv,
     },
     SubSecModifyDate => {
         Description => 'Modify Date',
         Groups => { 2 => 'Time' },
+        Writable => 1,
+        Shift => 0, # don't shift this tag
         Require => {
             0 => 'EXIF:ModifyDate',
+        },
+        Desire => {
             1 => 'SubSecTime',
-        },
-        ValueConv => q{
-            return undef if $val[1] eq '';
-            $_ = $val[0]; s/( \d{2}:\d{2}:\d{2})/$1\.$val[1]/; $_;
-        },
-        PrintConv => '$self->ConvertDateTime($val)',
+            2 => 'OffsetTime',
+        },
+        WriteAlso => {
+            'EXIF:ModifyDate' => '($val and $val=~/^(\d{4}:\d{2}:\d{2} \d{2}:\d{2}:\d{2})/) ? $1 : undef',
+            'EXIF:SubSecTime' => '($val and $val=~/\.(\d+)/) ? $1 : undef',
+            'EXIF:OffsetTime' => '($val and $val=~/([-+]\d{2}:\d{2}|Z)$/) ? ($1 eq "Z" ? "+00:00" : $1) : undef',
+        },
+        %subSecConv,
     },
     CFAPattern => {
@@ -2774,5 +4680,5 @@
             my @b = split / /, $val[1];
             return '?' unless @a==2 and @b==$a[0]*$a[1];
-            return Set16u($a[0]) . Set16u($a[1]) . pack('C*', @b);
+            return "$a[0] $a[1] @b";
         },
         PrintConv => 'Image::ExifTool::Exif::PrintCFAPattern($val)',
@@ -2788,7 +4694,8 @@
             5 => 'WB_GBRGLevels',
             6 => 'WB_RGBLevels',
-            7 => 'WB_RBLevels',
-            8 => 'WBRedLevel', # red
-            9 => 'WBGreenLevel',
+            7 => 'WB_GRBLevels',
+            8 => 'WB_RBLevels',
+            9 => 'WBRedLevel', # red
+           10 => 'WBGreenLevel',
         },
         ValueConv => 'Image::ExifTool::Exif::RedBlueBalance(0,@val)',
@@ -2805,7 +4712,8 @@
             5 => 'WB_GBRGLevels',
             6 => 'WB_RGBLevels',
-            7 => 'WB_RBLevels',
-            8 => 'WBBlueLevel', # blue
-            9 => 'WBGreenLevel',
+            7 => 'WB_GRBLevels',
+            8 => 'WB_RBLevels',
+            9 => 'WBBlueLevel', # blue
+           10 => 'WBGreenLevel',
         },
         ValueConv => 'Image::ExifTool::Exif::RedBlueBalance(1,@val)',
@@ -2818,20 +4726,24 @@
             1 => 'GPSLongitude',
         },
-        ValueConv => '"$val[0] $val[1]"',
+        Priority => 0,
+        ValueConv => '(length($val[0]) or length($val[1])) ? "$val[0] $val[1]" : undef',
         PrintConv => '"$prt[0], $prt[1]"',
     },
     LensID => {
         Groups => { 2 => 'Camera' },
-        Require => {
-            0 => 'LensType',
-        },
+        Require => 'LensType',
         Desire => {
             1 => 'FocalLength',
             2 => 'MaxAperture',
             3 => 'MaxApertureValue',
-            4 => 'ShortFocal',
-            5 => 'LongFocal',
+            4 => 'MinFocalLength',
+            5 => 'MaxFocalLength',
             6 => 'LensModel',
             7 => 'LensFocalRange',
+            8 => 'LensSpec',
+            9 => 'LensType2',
+            10 => 'LensType3',
+            11 => 'LensFocalLength', # (for Pentax to check for converter)
+            12 => 'RFLensType',
         },
         Notes => q{
@@ -2841,10 +4753,63 @@
         },
         # this LensID is only valid if the LensType has a PrintConv or is a model name
+        RawConv => q{
+            my $printConv = $$self{TAG_INFO}{LensType}{PrintConv};
+            return $val if ref $printConv eq 'HASH' or (ref $printConv eq 'ARRAY' and
+                ref $$printConv[0] eq 'HASH') or $val[0] =~ /(mm|\d\/F)/;
+            return undef;
+        },
+        ValueConv => '$val',
+        PrintConv => q{
+            my $pcv;
+            # use LensType2 instead of LensType if available and valid (Sony E-mount lenses)
+            # (0x8000 or greater; 0 for several older/3rd-party E-mount lenses)
+            if (defined $val[9] and ($val[9] & 0x8000 or $val[9] == 0)) {
+                $val[0] = $val[9];
+                $prt[0] = $prt[9];
+                # Particularly GM lenses: often LensType2=0 but LensType3 is available and valid: use LensType3.
+                if ($val[9] == 0 and $val[10] & 0x8000) {
+                   $val[0] = $val[10];
+                   $prt[0] = $prt[10];
+                }
+                $pcv = $$self{TAG_INFO}{LensType2}{PrintConv};
+            }
+            # use Canon RFLensType if available
+            if ($val[12]) {
+                $val[0] = $val[12];
+                $prt[0] = $prt[12];
+                $pcv = $$self{TAG_INFO}{RFLensType}{PrintConv};
+            }
+            my $lens = Image::ExifTool::Exif::PrintLensID($self, $prt[0], $pcv, $prt[8], @val);
+            # check for use of lens converter (Pentax K-3)
+            if ($val[11] and $val[1] and $lens) {
+                my $conv = $val[1] / $val[11];
+                $lens .= sprintf(' + %.1fx converter', $conv) if $conv > 1.1;
+            }
+            return $lens;
+        },
+    },
+    'LensID-2' => {
+        Name => 'LensID',
+        Groups => { 2 => 'Camera' },
+        Desire => {
+            0 => 'LensModel',
+            1 => 'Lens',
+            2 => 'XMP-aux:LensID',
+            3 => 'Make',
+        },
+        Inhibit => {
+            4 => 'Composite:LensID',
+        },
+        RawConv => q{
+            return undef if defined $val[2] and defined $val[3];
+            return $val if defined $val[0] and $val[0] =~ /(mm|\d\/F)/;
+            return $val if defined $val[1] and $val[1] =~ /(mm|\d\/F)/;
+            return undef;
+        },
         ValueConv => q{
-            return $val[0] if ref $$self{TAG_INFO}{LensType}{PrintConv} eq "HASH" or
-                              $prt[0] =~ /(mm|\d\/F)/;
-            return undef;
-        },
-        PrintConv => 'Image::ExifTool::Exif::PrintLensID($self, $prt[0], @val)',
+            return $val[0] if defined $val[0] and $val[0] =~ /(mm|\d\/F)/;
+            return $val[1];
+        },
+        PrintConv => '$_=$val; s/(\d)\/F/$1mm F/; s/mmF/mm F/; s/(\d) mm/${1}mm/; s/ - /-/; $_',
     },
 );
@@ -2874,9 +4839,9 @@
 sub IdentifyRawFile($$)
 {
-    my ($exifTool, $comp) = @_;
-    if ($$exifTool{FILE_TYPE} eq 'TIFF' and not $$exifTool{IdentifiedRawFile}) {
+    my ($et, $comp) = @_;
+    if ($$et{FILE_TYPE} eq 'TIFF' and not $$et{IdentifiedRawFile}) {
         if ($compression{$comp} and $compression{$comp} =~ /^\w+ ([A-Z]{3}) Compressed$/) {
-            $exifTool->OverrideFileType($$exifTool{TIFF_TYPE} = $1);
-            $$exifTool{IdentifiedRawFile} = 1;
+            $et->OverrideFileType($$et{TIFF_TYPE} = $1);
+            $$et{IdentifiedRawFile} = 1;
         }
     }
@@ -2897,21 +4862,25 @@
     }
     # (A light value of 0 is defined as f/1.0 at 1 second with ISO 100)
-    return (2*log($_[0]) - log($_[1]) - log($_[2]/100)) / log(2);
+    return log($_[0] * $_[0] * 100 / ($_[1] * $_[2])) / log(2);
 }
 
 #------------------------------------------------------------------------------
 # Calculate scale factor for 35mm effective focal length (ref 26/PH)
-# Inputs: 0) Focal length
-#         1) Focal length in 35mm format
-#         2) Canon digital zoom factor
-#         3) Focal plane diagonal size (in mm)
-#         4/5) Focal plane X/Y size (in mm)
-#         6) focal plane resolution units (1=None,2=inches,3=cm,4=mm,5=um)
-#         7/8) Focal plane X/Y resolution
-#         9/10,11/12...) Image width/height in order of precedence (first valid pair is used)
+# Inputs: 0) ExifTool object ref
+#         1) Focal length
+#         2) Focal length in 35mm format
+#         3) Canon digital zoom factor
+#         4) Focal plane diagonal size (in mm)
+#         5) Sensor size (X and Y in mm)
+#         6/7) Focal plane X/Y size (in mm)
+#         8) focal plane resolution units (1=None,2=inches,3=cm,4=mm,5=um)
+#         9/10) Focal plane X/Y resolution
+#         11/12,13/14...) Image width/height in order of precedence (first valid pair is used)
 # Returns: 35mm conversion factor (or undefined if it can't be calculated)
 sub CalcScaleFactor35efl
 {
-    my $res = $_[6];    # save resolution units (in case they have been converted to string)
+    my $et = shift;
+    my $res = $_[7];    # save resolution units (in case they have been converted to string)
+    my $sensXY = $_[4];
     Image::ExifTool::ToFloat(@_);
     my $focal = shift;
@@ -2922,13 +4891,27 @@
     my $digz = shift || 1;
     my $diag = shift;
+    my $sens = shift;
+    # calculate Canon sensor size using a dedicated algorithm
+    if ($$et{Make} eq 'Canon') {
+        require Image::ExifTool::Canon;
+        my $canonDiag = Image::ExifTool::Canon::CalcSensorDiag(
+            $$et{RATIONAL}{FocalPlaneXResolution},
+            $$et{RATIONAL}{FocalPlaneYResolution},
+        );
+        $diag = $canonDiag if $canonDiag;
+    }
     unless ($diag and Image::ExifTool::IsFloat($diag)) {
-        undef $diag;
-        my $xsize = shift;
-        my $ysize = shift;
-        if ($xsize and $ysize) {
-            # validate by checking aspect ratio because FocalPlaneX/YSize is not reliable
-            my $a = $xsize / $ysize;
-            if (abs($a-1.3333) < .1 or abs($a-1.5) < .1) {
-                $diag = sqrt($xsize * $xsize + $ysize * $ysize);
+        if ($sens and $sensXY =~ / (\d+(\.?\d*)?)$/) {
+            $diag = sqrt($sens * $sens + $1 * $1);
+        } else {
+            undef $diag;
+            my $xsize = shift;
+            my $ysize = shift;
+            if ($xsize and $ysize) {
+                # validate by checking aspect ratio because FocalPlaneX/YSize is not reliable
+                my $a = $xsize / $ysize;
+                if (abs($a-1.3333) < .1 or abs($a-1.5) < .1) {
+                    $diag = sqrt($xsize * $xsize + $ysize * $ysize);
+                }
             }
         }
@@ -2938,5 +4921,5 @@
             my $units = $lkup{ shift() || $res || '' } || 25.4;
             my $x_res = shift || return undef;
-            my $y_res = shift || return undef;
+            my $y_res = shift || $x_res;
             Image::ExifTool::IsFloat($x_res) and $x_res != 0 or return undef;
             Image::ExifTool::IsFloat($y_res) and $y_res != 0 or return undef;
@@ -2997,31 +4980,52 @@
 #------------------------------------------------------------------------------
 # Convert EXIF text to something readable
-# Inputs: 0) ExifTool object reference, 1) EXIF text
+# Inputs: 0) ExifTool object reference, 1) EXIF text,
+#         2) [optional] 1 to apply CharsetEXIF to ASCII text,
+#         3) tag name for warning message (may be argument 2)
 # Returns: text encoded according to Charset option (with trailing spaces removed)
-sub ConvertExifText($$)
+sub ConvertExifText($$;$$)
 {
-    my ($exifTool, $val) = @_;
+    my ($et, $val, $asciiFlex, $tag) = @_;
     return $val if length($val) < 8;
     my $id = substr($val, 0, 8);
     my $str = substr($val, 8);
+    my $type;
+
+    delete $$et{WrongByteOrder};
+    if ($$et{OPTIONS}{Validate} and $id =~ /^(ASCII|UNICODE|JIS)?\0* \0*$/) {
+        $et->Warn(($1 || 'Undefined') . ' text header' . ($tag ? " for $tag" : '') . ' has spaces instead of nulls');
+    }
     # Note: allow spaces instead of nulls in the ID codes because
     # it is fairly common for camera manufacturers to get this wrong
-    if ($id =~ /^(ASCII)?[\0 ]+$/) {
+    # (also handle Canon ZoomBrowser EX 4.5 null followed by 7 bytes of garbage)
+    if ($id =~ /^(ASCII)?(\0|[\0 ]+$)/) {
         # truncate at null terminator (shouldn't have a null based on the
         # EXIF spec, but it seems that few people actually read the spec)
         $str =~ s/\0.*//s;
+        # allow ASCII text to contain any other specified encoding
+        if ($asciiFlex and $asciiFlex eq '1') {
+            my $enc = $et->Options('CharsetEXIF');
+            $str = $et->Decode($str, $enc) if $enc;
+        }
     # by the EXIF spec, the following string should be "UNICODE\0", but
     # apparently Kodak sometimes uses "Unicode\0" in the APP3 "Meta" information.
     # However, unfortunately Ricoh uses "Unicode\0" in the RR30 EXIF UserComment
     # when the text is actually ASCII, so only recognize uppercase "UNICODE\0".
-    } elsif ($id =~ /^UNICODE[\0 ]$/) {
+    } elsif ($id =~ /^(UNICODE)[\0 ]$/) {
+        $type = $1;
         # MicrosoftPhoto writes as little-endian even in big-endian EXIF,
         # so we must guess at the true byte ordering
-        $str = $exifTool->Decode($str, 'UCS2', 'Unknown');
-    } elsif ($id =~ /^JIS[\0 ]{5}$/) {
-        $str = $exifTool->Decode($str, 'JIS', 'Unknown');
+        $str = $et->Decode($str, 'UTF16', 'Unknown');
+    } elsif ($id =~ /^(JIS)[\0 ]{5}$/) {
+        $type = $1;
+        $str = $et->Decode($str, 'JIS', 'Unknown');
     } else {
-        $exifTool->Warn("Invalid EXIF text encoding");
+        $tag = $asciiFlex if $asciiFlex and $asciiFlex ne '1';
+        $et->Warn('Invalid EXIF text encoding' . ($tag ? " for $tag" : ''));
         $str = $id . $str;
+    }
+    if ($$et{WrongByteOrder} and $$et{OPTIONS}{Validate}) {
+        $et->Warn('Wrong byte order for EXIF' . ($tag ? " $tag" : '') .
+                  ($type ? " $type" : '') . ' text');
     }
     $str =~ s/ +$//;    # trim trailing blanks
@@ -3088,5 +5092,5 @@
 #------------------------------------------------------------------------------
 # Calculate Red/BlueBalance
-# Inputs: 0) 0=red, 1=blue, 1-7) WB_RGGB/RGBG/RBGG/GRBG/GRGB/RGB/RBLevels,
+# Inputs: 0) 0=red, 1=blue, 1-8) WB_RGGB/RGBG/RBGG/GRBG/GRGB/RGB/GRB/RBLevels,
 #         8) red or blue level, 9) green level
 my @rggbLookup = (
@@ -3099,5 +5103,6 @@
     [ 2, 3, 0, 1 ], # 5 GBRG
     [ 0, 1, 1, 2 ], # 6 RGB
-    [ 0, 256, 256, 1 ], # 7 RB (green level is 256)
+    [ 1, 0, 0, 2 ], # 7 GRB
+    [ 0, 256, 256, 1 ], # 8 RB (green level is 256)
 );
 sub RedBlueBalance($@)
@@ -3138,29 +5143,84 @@
 
 #------------------------------------------------------------------------------
+# Print FNumber
+sub PrintFNumber($)
+{
+    my $val = shift;
+    if (Image::ExifTool::IsFloat($val) and $val > 0) {
+        # round to 1 decimal place, or 2 for values < 1.0
+        $val = sprintf(($val<1 ? "%.2f" : "%.1f"), $val);
+    }
+    return $val;
+}
+
+#------------------------------------------------------------------------------
+# Decode raw CFAPattern value
+# Inputs: 0) ExifTool ref, 1) binary value
+# Returns: string of numbers
+sub DecodeCFAPattern($$)
+{
+    my ($self, $val) = @_;
+    # some panasonic cameras (SV-AS3, SV-AS30) write this in ascii (very odd)
+    if ($val =~ /^[0-6]+$/) {
+        $self->Warn('Incorrectly formatted CFAPattern', 1);
+        $val =~ tr/0-6/\x00-\x06/;
+    }
+    return $val unless length($val) >= 4;
+    my @a = unpack(GetByteOrder() eq 'II' ? 'v2C*' : 'n2C*', $val);
+    my $end = 2 + $a[0] * $a[1];
+    if ($end > @a) {
+        # try swapping byte order (I have seen this order different than in EXIF)
+        my ($x, $y) = unpack('n2',pack('v2',$a[0],$a[1]));
+        if (@a < 2 + $x * $y) {
+            $self->Warn('Invalid CFAPattern', 1);
+        } else {
+            ($a[0], $a[1]) = ($x, $y);
+            # (can't technically be wrong because the order isn't well defined by the EXIF spec)
+            # $self->Warn('Wrong byte order for CFAPattern');
+        }
+    }
+    return "@a";
+}
+
+#------------------------------------------------------------------------------
 # Print CFA Pattern
 sub PrintCFAPattern($)
 {
     my $val = shift;
-    return '<truncated data>' unless length $val > 4;
-    # some panasonic cameras (SV-AS3, SV-AS30) write this in ascii (very odd)
-    $val =~ /^[0-6]+$/ and $val =~ tr/0-6/\x00-\x06/;
-    my ($nx, $ny) = (Get16u(\$val, 0), Get16u(\$val, 2));
-    return '<zero pattern size>' unless $nx and $ny;
-    my $end = 4 + $nx * $ny;
-    if ($end > length $val) {
-        # try swapping byte order (I have seen this order different than in EXIF)
-        ($nx, $ny) = unpack('n2',pack('v2',$nx,$ny));
-        $end = 4 + $nx * $ny;
-        return '<invalid pattern size>' if $end > length $val;
-    }
+    my @a = split ' ', $val;
+    return '<truncated data>' unless @a >= 2;
+    return '<zero pattern size>' unless $a[0] and $a[1];
+    my $end = 2 + $a[0] * $a[1];
+    return '<invalid pattern size>' if $end > @a;
     my @cfaColor = qw(Red Green Blue Cyan Magenta Yellow White);
-    my ($pos, $rtnVal) = (4, '[');
+    my ($pos, $rtnVal) = (2, '[');
     for (;;) {
-        $rtnVal .= $cfaColor[Get8u(\$val,$pos)] || 'Unknown';
+        $rtnVal .= $cfaColor[$a[$pos]] || 'Unknown';
         last if ++$pos >= $end;
-        ($pos - 4) % $ny and $rtnVal .= ',', next;
+        ($pos - 2) % $a[1] and $rtnVal .= ',', next;
         $rtnVal .= '][';
     }
     return $rtnVal . ']';
+}
+
+#------------------------------------------------------------------------------
+# Print Opcode List
+# Inputs: 0) value, 1) flag for inverse conversion, 2) conversion hash reference
+# Returns: converted value
+sub PrintOpcode($$$)
+{
+    my ($val, $inv, $conv) = @_;
+    return undef if $inv;   # (can't do inverse conversion)
+    return '' unless length $$val > 4;
+    my $num = unpack('N', $$val);
+    my $pos = 4;
+    my ($i, @ops);
+    for ($i=0; $i<$num; ++$i) {
+        $pos + 16 <= length $$val or push(@ops, '<err>'), last;
+        my ($op, $ver, $flags, $len) = unpack("x${pos}N4", $$val);
+        push @ops, $$conv{$op} || "[opcode $op]";
+        $pos += 16 + $len;
+    }
+    return join ', ', @ops;
 }
 
@@ -3181,7 +5241,9 @@
     }
     return $val unless $c == 4;
-    $val = "$vals[1]mm f/$vals[2]";
-    $val = "$vals[0]-$val" if $vals[0] ne $vals[1];
-    $val .= "-$vals[3]" if $vals[3] ne $vals[2];
+    $val = $vals[0];
+    # (the Pentax Q writes zero for upper value of fixed-focal-length lenses)
+    $val .= "-$vals[1]" if $vals[1] and $vals[1] ne $vals[0];
+    $val .= "mm f/$vals[2]";
+    $val .= "-$vals[3]" if $vals[3] and $vals[3] ne $vals[2];
     return $val;
 }
@@ -3211,29 +5273,116 @@
 
 #------------------------------------------------------------------------------
+# Match lens in list of possbilities based on value of LensModel
+# Inputs: 0) reference to list of possible models, 1) LensModel string
+# - updates list on return; guaranteed not to remove all list entries
+sub MatchLensModel($$)
+{
+    my ($try, $lensModel) = @_;
+    if (@$try > 1 and $lensModel) {
+        my (@filt, $pat);
+        # filter by focal length
+        if ($lensModel =~ /((\d+-)?\d+mm)/) {
+            my $focal = $1;
+            @filt = grep /$focal/, @$try;
+            @$try = @filt if @filt and @filt < @$try;
+        }
+        # filter by aperture
+        if (@$try > 1 and $lensModel =~ m{(?:F/?|1:)(\d+(\.\d+)?)}i) {
+            my $fnum = $1;
+            @filt = grep m{(F/?|1:)$fnum(\b|[A-Z])}i, @$try;
+            @$try = @filt if @filt and @filt < @$try;
+        }
+        # filter by model version, and other lens parameters
+        foreach $pat ('I+', 'USM') {
+            next unless @$try > 1 and $lensModel =~ /\b($pat)\b/;
+            my $val = $1;
+            @filt = grep /\b$val\b/, @$try;
+            @$try = @filt if @filt and @filt < @$try;
+        }
+    }
+}
+
+#------------------------------------------------------------------------------
 # Attempt to identify the specific lens if multiple lenses have the same LensType
-# Inputs: 0) ExifTool object ref, 1) LensType string, 2) LensType value,
-#         3) FocalLength, 4) MaxAperture, 5) MaxApertureValue, 6) ShortFocal,
-#         7) LongFocal, 8) LensModel, 9) LensFocalRange
+# Inputs: 0) ExifTool object ref, 1) LensType print value, 2) PrintConv hash ref,
+#         3) LensSpec print value, 4) LensType numerical value, 5) FocalLength,
+#         6) MaxAperture, 7) MaxApertureValue, 8) MinFocalLength, 9) MaxFocalLength,
+#         10) LensModel, 11) LensFocalRange, 12) LensSpec
+my %sonyEtype;
 sub PrintLensID($$@)
 {
-    my ($exifTool, $lensTypePrt, $lensType, $focalLength, $maxAperture,
-        $maxApertureValue, $shortFocal, $longFocal, $lensModel, $lensFocalRange) = @_;
-    # the rest of the logic relies on the LensType lookup:
+    my ($et, $lensTypePrt, $printConv, $lensSpecPrt, $lensType, $focalLength,
+        $maxAperture, $maxApertureValue, $shortFocal, $longFocal, $lensModel,
+        $lensFocalRange, $lensSpec) = @_;
+    # this logic relies on the LensType lookup:
     return undef unless defined $lensType;
-    my $printConv = $exifTool->{TAG_INFO}{LensType}{PrintConv};
+    # get print conversion hash if necessary
+    $printConv or $printConv = $$et{TAG_INFO}{LensType}{PrintConv};
     # just copy LensType PrintConv value if it was a lens name
     # (Olympus or Panasonic -- just exclude things like Nikon and Leaf LensType)
     unless (ref $printConv eq 'HASH') {
-        return $lensTypePrt if $lensTypePrt =~ /mm/;
-        return $lensTypePrt if $lensTypePrt =~ s/(\d)\/F/$1mm F/;
-        return undef;
+        if (ref $printConv eq 'ARRAY' and ref $$printConv[0] eq 'HASH') {
+            $printConv = $$printConv[0];
+            $lensTypePrt =~ s/;.*//;
+            $lensType =~ s/ .*//;
+        } else {
+            return $lensTypePrt if $lensTypePrt =~ /mm/;
+            return $lensTypePrt if $lensTypePrt =~ s/(\d)\/F/$1mm F/;
+            return undef;
+        }
+    }
+    # get LensSpec information if available (Sony)
+    my ($sf0, $lf0, $sa0, $la0);
+    if ($lensSpecPrt) {
+        ($sf0, $lf0, $sa0, $la0) = GetLensInfo($lensSpecPrt);
+        undef $sf0 unless $sa0; # (make sure aperture isn't zero)
     }
     # use MaxApertureValue if MaxAperture is not available
     $maxAperture = $maxApertureValue unless $maxAperture;
-    if ($lensFocalRange and $lensFocalRange =~ /^(\d+)(?: to (\d+))?$/) {
+    if ($lensFocalRange and $lensFocalRange =~ /^(\d+)(?: (?:to )?(\d+))?$/) {
         ($shortFocal, $longFocal) = ($1, $2 || $1);
     }
-    if ($shortFocal and $longFocal) {
-        # Canon includes makernote information which allows better lens identification
+    if ($$et{Make} eq 'SONY') {
+        if ($lensType eq 65535) {
+            # handle Sony E-type lenses when LensType2 isn't valid (NEX/ILCE models only)
+            if ($$et{Model} =~ /NEX|ILCE/) {
+                unless (%sonyEtype) {
+                    my ($index, $i, %did, $lens);
+                    require Image::ExifTool::Sony;
+                    foreach (sort keys %Image::ExifTool::Sony::sonyLensTypes2) {
+                        ($lens = $Image::ExifTool::Sony::sonyLensTypes2{$_}) =~ s/ or .*//;
+                        next if $did{$lens};
+                        ($i, $index) = $index ? ("65535.$index", $index + 1) : (65535, 1);
+                        $did{$sonyEtype{$i} = $lens} = 1;
+                    }
+                }
+                $printConv = \%sonyEtype;
+            }
+        } elsif ($lensType != 0xff00) {
+            # Patch for Metabones or other adapters on Sony E-mount cameras (ref Jos Roost)
+            # Metabones Canon EF to E-mount adapters add 0xef00, 0xbc00 or 0x7700 to the
+            # high byte for 2-byte Canon LensType values, so we need to adjust for these.
+            # Offset 0xef00 is also used by Sigma MC-11, Fotodiox and Viltrox EF-E adapters.
+            # Have to exclude A-mount Sigma Filtermatic with 'odd' LensType=0xff00.
+            require Image::ExifTool::Minolta;
+            if ($Image::ExifTool::Minolta::metabonesID{$lensType & 0xff00}) {
+                $lensType -= ($lensType >= 0xef00 ? 0xef00 : $lensType >= 0xbc00 ? 0xbc00 : 0x7700);
+                require Image::ExifTool::Canon;
+                $printConv = \%Image::ExifTool::Canon::canonLensTypes;
+                $lensTypePrt = $$printConv{$lensType} if $$printConv{$lensType};
+            # Test for Sigma MC-11 SA-E adapter with Sigma SA lens using 0x4900 offset.
+            # (upper limit of test cuts off two highest Sigma lenses, but prevents
+            # conflict with old Minolta 25xxx and higher ID's)
+            } elsif ($lensType >= 0x4900 and $lensType <= 0x590a) {
+                require Image::ExifTool::Sigma;
+                $lensType -= 0x4900;
+                $printConv = \%Image::ExifTool::Sigma::sigmaLensTypes;
+                $lensTypePrt = $$printConv{$lensType} if $$printConv{$lensType};
+            }
+        }
+    # (Min/MaxFocalLength may report the current focal length for Tamron zoom lenses)
+    } elsif ($shortFocal and $longFocal and (not $lensModel or $lensModel !~ /^TAMRON.*-\d+mm/)) {
+        # Canon (and some other makes) include makernote information
+        # which allows better lens identification
         require Image::ExifTool::Canon;
         return Image::ExifTool::Canon::PrintLensID($printConv, $lensType,
@@ -3253,10 +5402,30 @@
     my (@matches, @best, @user, $diff);
     foreach $lens (@lenses) {
-        if ($Image::ExifTool::userLens{$lens}) {
-            push @user, $lens;
+        push @user, $lens if $Image::ExifTool::userLens{$lens};
+        # sf = short focal
+        # lf = long focal
+        # sa = max aperture at short focal
+        # la = max aperture at long focal
+        my ($sf, $lf, $sa, $la) = GetLensInfo($lens);
+        next unless $sf;
+        # check against LensSpec parameters if available
+        if ($sf0) {
+            next if abs($sf - $sf0) > 0.5 or abs($sa - $sa0) > 0.15 or
+                    abs($lf - $lf0) > 0.5 or abs($la - $la0) > 0.15;
+            # the basic parameters match, but also check against additional lens features:
+            # for Sony A and E lenses, the full LensSpec string should match with end of LensType,
+            # excluding any part between () at the end, and preceded by a space (the space
+            # ensures that e.g. Zeiss Loxia 21mm having LensSpec "E 21mm F2.8" will not be
+            # identified as "Sony FE 21mm F2.8 (SEL28F20 + SEL075UWC)")
+            $lensSpecPrt and $lens =~ / \Q$lensSpecPrt\E( \(| GM$|$)/ and @best = ( $lens ), last;
+            # exactly-matching Sony lens should have been found above, so only add non-Sony lenses
+            push @best, $lens unless $lens =~ /^Sony /;
             next;
         }
-        my ($sf, $lf, $sa, $la) = GetLensInfo($lens);
-        next unless $sf;
+        # adjust focal length and aperture if teleconverter is attached (Minolta)
+        if ($lens =~ / \+ .*? (\d+(\.\d+)?)x( |$)/) {
+            $sf *= $1;  $lf *= $1;
+            $sa *= $1;  $la *= $1;
+        }
         # see if we can rule out this lens using FocalLength and MaxAperture
         if ($focalLength) {
@@ -3274,6 +5443,9 @@
             # now determine the best match for this aperture
             my $aa; # approximate maximum aperture at this focal length
-            if ($sf == $lf or $sa == $la) {
+            if ($sf == $lf or $sa == $la or $focalLength <= $sf) {
+                # either 1) prime lens, 2) fixed-aperture zoom, or 3) zoom at min focal
                 $aa = $sa;
+            } elsif ($focalLength >= $lf) {
+                $aa = $la;
             } else {
                 # assume a log-log variation of max aperture with focal length
@@ -3281,4 +5453,6 @@
                 $aa = exp(log($sa) + (log($la)-log($sa)) / (log($lf)-log($sf)) *
                                      (log($focalLength)-log($sf)));
+                # a linear relationship between 1/FocalLength and 1/MaxAperture fits Sony better (ref 27)
+                #$aa = 1 / (1/$sa + (1/$focalLength - 1/$sf) * (1/$la - 1/$sa) / (1/$lf - 1/$sf));
             }
             my $d = abs($maxAperture - $aa);
